package de.uni_passau.fim.PADAS.group3.DataDash.model;

import java.util.List;
import java.util.UUID;
import java.sql.Date;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

public interface dataRepository extends JpaRepository<Dataset, UUID>{

    Dataset getDatasetById(UUID id);
    List<Dataset> findByTitle(String title);
    List<Dataset> findByTitleLike(String title);
    List<Dataset> findByAuthorLike(String author);
    List<Dataset> findByType(Type type);
    List<Dataset> findByAuthor(String author);
    List<Dataset> findByAbstLike(String abst);
    List<Dataset> findByDescriptionLike(String description);
    List<Dataset> findByCategories(String[] categories);
    List<Dataset> findByRaitingGreaterThan(float raiting);
    List<Dataset> findByVotesGreaterThan(int votes);
    List<Dataset> findByDateAfter(Date date);
    List<Dataset> findByDateBefore(Date date);
    List<Dataset> findByDateBetween(Date date1, Date date2);
    List<Dataset> findAll();

    @Query("SELECT d FROM Dataset d WHERE d.title LIKE :title AND d.author LIKE :author AND d.abst LIKE :abst AND d.description LIKE :description")
    List<Dataset> findBy(@Param("title") String title, @Param("author") String author, @Param("abst") String abst, @Param("description") String description);


    
}